/* 

     
//	DOGM128/132 Test

// 	15.04.20011 Display EA DOGM128

// 	** Achtung bitte eigenen Takt einstellen! **
// 	hier: Atxmega128a3   32Mhz ->  External 16Mhz clock source on XTAL1 initialization (PLL*2)

// 	LCD Pin Beschaltung

				Atxmega128a3				DOGM128/132
----------------------------------------------------------------------
**Port darf gendert werden, nderung in der dog-graphic.h**

PORT_A0     2     // PC2 (Pin 18)	-> Display A0	PIN 38
PORT_RST    3     // PC3 (Pin 19) 	-> Display RST	PIN 39
PORT_CS     4     // PC4 (Pin 20) 	-> Display CS0	PIN 40 // Wichtig 10K Widerstand nach3,3V


**SPI-Port darf nicht gendert werden!!**

SPI_MOSI    5     // PC5 (Pin 21) -> Display MOSI	PIN 36
SPI_MISO   											leer 
SPI_SCK     7     // PC7 (Pin 23) -> Display SCK	PIN 37
-----------------------------------------------------------------------

*/

#include "tools.h"
 	
	// bindet printf() ein
	static FILE mystdout = FDEV_SETUP_STREAM(dogm_putchar, NULL, _FDEV_SETUP_WRITE);




int main(void)
{


	stdout = &mystdout; // bindet printf() ein 
	system_clocks_init(); // System Clocks initialization
	

	// Enable HI/MED/LO interrupt level
	// Interupt einschalten
	PMIC.CTRL |= PMIC_HILVLEN_bm; 
	PMIC.CTRL |= PMIC_MEDLVLEN_bm;
	PMIC.CTRL |= PMIC_LOLVLEN_bm;
	
	sei(); 

	
	
	SPI_PORT_Init(); 	// SPI Port Init
 	SPI_Init();			// SPI Init
	lcd_init();			// DOGM Init
	delay_ms(100);  	// 100ms warten Display Init
	
	lcd_set_font(FONT_PROP_8, NORMAL); 			// fr xprintf vorbereiten

	lcd_moveto_xy(1,20); printf("DOGM128-Test");// Anzeige 
	
	lcd_set_font(FONT_PROP_16, NORMAL); 		// Gro-Schrift

	lcd_moveto_xy(4,20); printf("DOGM128-Test");// Anzeige
		
	lcd_set_font(FONT_PROP_8, NORMAL); 			// zurck zur Normal-Schrift 
		
		
		
		while(true) 
		{  
		
		nop();
		
		}		


		return (0);
}

void system_clocks_init(void)
{
	unsigned char n,s;

	/// Save interrupts enabled/disabled state
	s=SREG;
	// Disable interrupts
	cli();

	// Internal 32 MHz RC oscillator initialization
	// Enable the internal 32 MHz RC oscillator
	OSC.CTRL|=OSC_RC32MEN_bm;

	// System Clock prescaler A division factor: 2
	// System Clock prescalers B & C division factors: B:1, C:1
	// ClkPer4: 16000,000 kHz
	// ClkPer2: 16000,000 kHz
	// ClkPer:  16000,000 kHz
	// ClkCPU:  16000,000 kHz
	n=(CLK.PSCTRL & (~(CLK_PSADIV_gm | CLK_PSBCDIV1_bm | CLK_PSBCDIV0_bm))) |
	CLK_PSADIV_2_gc | CLK_PSBCDIV_1_1_gc; // Hier kann der Takt umgestellt werden!! 
	CCP=CCP_IOREG_gc;
	CLK.PSCTRL=n;

	// Disable the autocalibration of the internal 32 MHz RC oscillator
	DFLLRC32M.CTRL&= ~DFLL_ENABLE_bm;

	// Wait for the internal 32 MHz RC oscillator to stabilize
	while ((OSC.STATUS & OSC_RC32MRDY_bm)==0);

	// Select the system clock source: 32 MHz Internal RC Osc.
	n=(CLK.CTRL & (~CLK_SCLKSEL_gm)) | CLK_SCLKSEL_RC32M_gc;
	CCP=CCP_IOREG_gc;
	CLK.CTRL=n;

	// Disable the unused oscillators: 2 MHz, internal 32 kHz, external clock/crystal oscillator, PLL
	OSC.CTRL&= ~(OSC_RC2MEN_bm | OSC_RC32KEN_bm | OSC_XOSCEN_bm | OSC_PLLEN_bm);

	// Peripheral Clock output: Disabled
	PORTCFG.CLKEVOUT=(PORTCFG.CLKEVOUT & (~PORTCFG_CLKOUT_gm)) | PORTCFG_CLKOUT_OFF_gc;

	// Restore interrupts enabled/disabled state
	SREG=s;
	}




int dogm_putchar(char c, FILE *stream) // // bindet printf() ein
{
 	lcd_putc(c);
    return 0;
}


